<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- This file has been generated by tj3man v3.1.0 -->
<html lang="en" xml:lang="en" xmlns="http://www.w3.org/1999/xhtml">
 <head>
  <title>Tutorial</title>
  <meta content="text/html; charset=utf-8" http-equiv="Content-Type"/>
 </head>
 <link href="css/tjmanual.css" rel="stylesheet" type="text/css"></link>
 <body>
  <div align="center">
   <h3 align="center">The TaskJuggler User Manual</h3>
   <em align="center">Project Management beyond Gantt Chart Drawing</em>
  </div>
  <br/>
  <hr/>
  <table style="width:90%; margin-left:5%; margin-right:5%"><tr>
    <td style="text-align:left; width:35%;">&lt;&lt; <a href="Getting_Started.html">Getting_Started</a> &lt;&lt;</td>
    <td style="text-align:center; width:30%;"><a href="toc.html">Table Of Contents</a></td>
    <td style="text-align:right; width:35%;">&gt;&gt; <a href="The_TaskJuggler_Syntax.html">The_TaskJuggler_Syntax</a> &gt;&gt;</td>
   </tr></table>
  <hr/>
  <br/>
  <div style="width:90%; margin-left:5%; margin-right:5%"><div class="manual">
    <h1 class="manual" id="The_Tutorial_Your_first_Project">4 The Tutorial: Your first Project</h1>
    <p class="manual">We have mentioned already that TaskJuggler uses plain text files that describe the project to schedule it. As you will see now, the syntax of these files is easy to understand and very intuitive. This chapter will walk you step by step through your first project. You create the project plan for a made-up accounting software project. This project demonstrates some of the commonly used features of TaskJuggler. The complete example can be downloaded <a href="http://www.taskjuggler.org/tj3/examples/Tutorial/tutorial.tjp" target="_top">here</a>. The resulting reports can be found <a href="http://www.taskjuggler.org/tj3/examples/Tutorial/Overview.html" target="_top">here</a>.</p>
    <h2 class="manual" id="Starting_the_project">4.1 Starting the project</h2>
    <p class="manual">To start a TaskJuggler project file you need to use the <a href="project.html">project</a> property. It tells TaskJuggler the name of your project and a start and end date. The start and end dates don't need to be exact, but must fit all tasks of the project. It is the time interval the TaskJuggler scheduler will use to fit the tasks in. So, make it large enough for all your tasks to fit in. But don't make it too large, because this will result in longer scheduling times and higher memory consumption.</p>
    <div class="codeframe"><pre class="code">project acso "Accounting Software"  2002-01-16 +4m {
}
</pre></div>
    <p class="manual">All TaskJuggler properties have two required attributes, a unique ID and a name, and a set of optional attributes. The name must always be specified. The ID can be omitted if you never have to reference the property from another context. If you omit the ID, TaskJuggler will automatically generate a unique ID. The other optional attributes are always enclosed in curly braces. If no optional attributes are specified, the braces can be omitted as well. In this example we will introduce a number of there attributes that may or may not matter to you. If you don't see an immediate need for a specific attribute, feel free to ignore it for now. You can always come back to them later. A full list of the supported attributes can be found in the <i>attributes</i> section of the <a href="project.html">project</a> property documentation.</p>
    <p class="manual">Attributes always start with a keyword that is unique in the context. A context is delimited by a set of curly braces that enclose optional attributes of a property. The area between properties is called the global scope. Usually, attributes have one or more arguments. These arguments can be dates, character strings, numbers or symbols. Strings must be enclosed in single or double quotes. The argument types and meaning is explained for each keyword in the syntax reference section of this manual.</p>
    <p class="manual">TaskJuggler manages all events with an accuracy of up to 15 minutes. In many cases, you don't care about this level of accuracy. Nevertheless, it's good to have it when you need it. All dates can optionally be extended by a time. By default, TaskJuggler assumes that all times are UTC (world time) times. If you prefer a different time zone, you need to use the <a href="timezone.html">timezone</a> attribute.</p>
    <div class="codeframe"><pre class="code">  timezone "Europe/Paris"
</pre></div>
    <p class="manual">Be aware that the project start and end dates in the project header are specified before you specify the time zone. The project header dates are always assumed to be UTC unless you specify differently. See <a href="interval2.html">interval2</a> for details.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">project acso "Accounting Software"  2002-01-16-0:00-+0100
</pre></div>
    <p class="manual">The <a href="currency.html">currency</a> attribute specifies the unit of currency values.</p>
    <div class="codeframe"><pre class="code">  currency "USD"
</pre></div>
    <p class="manual">Because each culture has its own way of specifying dates and numbers, the format for these are configurable. Use the <a href="timeformat.html">timeformat</a> attribute to specify the default format for dates. This format is used for reports, it does not affect the way you specify dates in the project files. Here you always need to use the <a href="date.html">ISO standardized
notation</a>.</p>
    <div class="codeframe"><pre class="code">  timeformat "%Y-%m-%d"
  numberformat "-" "" "," "." 1
  currencyformat "(" ")" "," "." 0
</pre></div>
    <p class="manual">We also can specify the way numbers or currency values are shown in the reports. Use the <a href="numberformat.html">numberformat</a> and <a href="currencyformat.html">currencyformat</a> attributes for this.</p>
    <p class="manual">The optional attribute <a href="now.html">now</a> is used to set the current day for the scheduler to another value than to the moment your invoke TaskJuggler. When this attribute is not present, TaskJuggler will use the current moment of time to determine where you are with your tasks. To get a defined result for the reports in this example we've picked a specific date that fits our purpose here. In your projects, you would use <a href="now.html">now</a> to generate status reports for the date you specify.</p>
    <div class="codeframe"><pre class="code">  now 2002-03-05-13:00
</pre></div>
    <p class="manual">In this tutorial we would like to compare two scenarios of the project. The first scenario is the one that we have planned. The second scenario is how it really happened. The two scenarios have the same task structure, but the start and end dates of the task may vary. In reality we assume that the project got delayed, so we call the second scenario "Delayed". The scenario property is used to specify the scenarios. The delayed scenario is nested into the plan scenario. This tells TaskJuggler to use all values from the plan scenario also for the second scenario unless the second scenario has it's own values. This is a very easy but also powerful way to analyze the impact of certain changes to the plan of record. We'll see further below, how to specify values for a scenario and how to compare the results.</p>
    <div class="codeframe"><pre class="code">  scenario plan "Plan" {
    scenario delayed "Delayed"
  }
</pre></div>
    <p class="manual">To summarize the above, let's look at the complete header again. Don't get scared by the wealth of attributes here. They are all optional and mostly used to illustrate the flexibility of TaskJuggler.</p>
    <div class="codeframe"><pre class="code">project acso "Accounting Software"  2002-01-16 +4m {
  # Set the default time zone for the project. If not specified, UTC
  # is used.
  timezone "Europe/Paris"
  # Hide the clock time. Only show the date.
  timeformat "%Y-%m-%d"
  # Use US format for numbers
  numberformat "-" "" "," "." 1
  # Use US financial format for currency values. Don't show cents.
  currencyformat "(" ")" "," "." 0
  # Pick a day during the project that will be reported as 'today' in
  # the project reports. If not specified, the current day will be
  # used, but this will likely be outside of the project range, so it
  # can't be seen in the reports.
  now 2002-03-05-13:00
  # The currency for all money values is the Euro.
  currency "USD"

  # We want to compare the baseline scenario to one with a slightly
  # delayed start.
  scenario plan "Plan" {
    scenario delayed "Delayed"
  }
  extend resource {
    text Phone "Phone"
  }
}
</pre></div>
    <h2 class="manual" id="Global_Attributes">4.2 Global Attributes</h2>
    <p class="manual">For this tutorial, we also like to do a simple profit and loss analysis of the project. We will track labor cost versus customer payments. To calculate the labor costs we have to specify the default daily costs of an employee. This can be changed for certain employees later, but it illustrates an important concept of TaskJuggler – inheritance of attributes. In order to reduce the size of the TaskJuggler project file to a readable minimum, properties inherit many optional attributes from their enclosing scopes. We'll see further below, what this actually means. Right after the project property we are at top-level scope, so this is the default for all following properties.</p>
    <div class="codeframe"><pre class="code">rate 390.0
</pre></div>
    <p class="manual">The <a href="rate.html">rate</a> attribute can be used to specify the daily costs of resources. All subsequent resources will get this rate. But it can be changed to a different rate at group or individual resource level.</p>
    <p class="manual">You may also want to tell TaskJuggler about holidays that affect all resources. Global vacations are time periods where TaskJuggler does not do any resource assignments to tasks.</p>
    <div class="codeframe"><pre class="code">leaves holiday "Good Friday" 2002-03-29
</pre></div>
    <p class="manual">Use the <a href="vacation.html">vacation</a> attribute to define a global vacation. Global vacations must have a name and a date or date range. This is slightly different from vacations of individual resources. They are defined with the <a href="vacation.resource.html">vacation attribute for resources</a> where the name is optional. The vacation name is purely for documentation purposes.</p>
    <h2 class="manual" id="Macros">4.3 Macros</h2>
    <p class="manual">Macros are another TaskJuggler feature to keep project files small. Macros are text patterns that can be defined once and inserted multiple times in the project file. A <a href="macro.html">macro</a> always has a name and the text pattern is enclosed by square brackets.</p>
    <div class="codeframe"><pre class="code">macro allocate_developers [
  allocate dev1
  allocate dev2
  allocate dev3
]
</pre></div>
    <p class="manual">To use the macro you simply have to write <code class="manual">${allocate_developers}</code> and TaskJuggler will replace the term <code class="manual">${allocate_developers}</code> with the pattern. We will use this macro further below in the example and then explain the meaning of the pattern.</p>
    <h2 class="manual" id="Declaring_Flags">4.4 Declaring Flags</h2>
    <p class="manual">A TaskJuggler feature that you will probably make heavy use of is flags. Once declared you can attach them to many properties. When you generate reports of the TaskJuggler results, you can use the flags to filter out information and limit the report to exactly those details that you want to have included.</p>
    <div class="codeframe"><pre class="code">flags team
</pre></div>
    <p class="manual">This is flag declaration. All <a href="flags.html">flags</a> need to be declared, before they can be used to avoid hard to find errors due to misspelled flag names. The flags should be declared shortly below the project header. We will see further down, how we can make use of these flags.</p>
    <h2 class="manual" id="Declaring_Accounts">4.5 Declaring Accounts</h2>
    <p class="manual">The use of our resources will create costs. For a profit and loss analysis, we need to balance the costs against the customer payments. In order not to get lost with all the various amounts, we declare 3 <a href="account.html">accounts</a> to credit the amounts to. We create one account for the development costs, one for the documentation costs, and one for the customer payments.</p>
    <div class="codeframe"><pre class="code">account cost "Project Cost" {
  account dev "Development"
  account doc "Documentation"
}
account rev "Payments"
</pre></div>
    <p class="manual">Like all TaskJuggler properties, the account needs an ID and a name. IDs may only consist of the characters a to z, A to Z and the underscore. All but the first character may also be digits 0 to 9. All global TaskJuggler properties have IDs. The ID is necessary so that we can reference the property again later without having to write the potentially much longer name. The name may contain space characters and therefore has to be enclosed with single or double quotes.</p>
    <p class="manual">Accounts can be grouped by nesting them. You can use this feature to create sets of accounts. Such sets can then be balanced against each other to create a profit and loss analysis. When you have specified accounts in your project, you must at least define one default <a href="balance.html">balance</a>.</p>
    <div class="codeframe"><pre class="code">balance cost rev
</pre></div>
    <h2 class="manual" id="Declaring_Resources">4.6 Declaring Resources</h2>
    <p class="manual">While the above introduced account property is only needed if you want to do a P&amp;L analysis, resources are usually found in almost any project.</p>
    <div class="codeframe"><pre class="code">resource boss "Paul Henry Bullock" {
  email "phb@crappysoftware.com"
  Phone "x100"
  rate 480
}
resource dev "Developers" {
  managers boss
  resource dev1 "Paul Smith" {
    email "paul@crappysoftware.com"
    Phone "x362"
    rate 350.0
  }
  resource dev2 "Sébastien Bono" {
    email "SBono@crappysoftware.com"
    Phone "x234"
  }
  resource dev3 "Klaus Müller" {
    email "Klaus.Mueller@crappysoftware.com"
    Phone "x490"
    leaves annual 2002-02-01 - 2002-02-05
  }
  flags team
}
resource misc "The Others" {
  managers boss
  resource test "Peter Murphy" {
    email "murphy@crappysoftware.com"
    Phone "x666"
    limits { dailymax 6.4h }
    rate 310.0
  }
  resource doc "Dim Sung" {
    email "sung@crappysoftware.com"
    Phone "x482"
    rate 300.0
    leaves annual 2002-03-11 - 2002-03-16
  }

  flags team
}
</pre></div>
    <p class="manual">This snippet of the example shows the use of the <a href="resource.html">
resource property</a>. Just like accounts, resources always have an ID and a Name. These IDs also need to be unique within their property class. Names are strings and as such enclosed in double quotes. As you can see, resource properties can be nested: <code class="manual">dev</code> is a group or container resource, a team that consists of three other resources.</p>
    <p class="manual">
     <code class="manual">dev1</code>, alias Paul Smith, costs more than the normal employee. So the declaration of <code class="manual">dev1</code> overwrites the inherited default rate with a higher value.</p>
    <p class="manual">The default value has been inherited from the enclosing scope, resource <code class="manual">dev</code>, which in turn has inherited it from the global scope. The declaration of the resource Klaus Müller uses another optional attribute. With vacation you can specify a certain time interval where the resource is not available. Vacations are list attributes. They accumulate the declarations. If you want to get rid of inherited values, you can use the <a href="purge.html">purge</a> attribute to clear the list.</p>
    <p class="manual">It is important that you understand how TaskJuggler handles time intervals. Internally, TaskJuggler uses the number of seconds after January 1st, 1970 to store any date. So all dates are actually stored with an accuracy of 1 second in UTC time. <code class="manual">2002-02-01</code> specifies midnight February 1st, 2002. Following the TaskJuggler concept of requiring as little information as necessary and extending the rest with sensible defaults, TaskJuggler adds the time 0:00:00 if nothing else has been specified. So the vacation ends on midnight February 5th, 2002. Well, almost. Every time you specify a time interval, the end date is not included in the interval. So Klaus Müller's vacation ends exactly at 0:00:00 on February 4th, 2002.</p>
    <p class="manual">Peter Murphy only works 6.4 hours a day. So we use the <a href="limits.resource.html">limits</a> attribute to limit his daily working hours. We could also define exact working hours using the <a href="shift.html">shift
property</a>, but we ignore this for now.</p>
    <p class="manual">Note that we have attached the flag team after the declaration of the sub-resources to the team resources. This way, these flags don't get passed down to the sub-resources. If we would have declared the flags before the sub-resources, then they would have the flags attached as well.</p>
    <h2 class="manual" id="Specifying_the_Tasks">4.7 Specifying the Tasks</h2>
    <p class="manual">Let's focus on the real work now. The project should solve a problem: the creation of an accounting software. Because the job is quite complicated, we break it down into several subtasks. We need to do a specification, develop the software, test the software, and write a manual. Using the <a href="task.html">task property</a>, thiis would look as follows:</p>
    <div class="codeframe"><pre class="code">task AcSo "Accounting Software" {
  task spec "Specification" {
  }
  task software "Software Development" {
  }
  task test "Software testing" {
  }
  task manual "Manual" {
    journalentry 2002-02-28 "User manual completed" {
      author boss
      summary "The doc writers did a really great job to finish on time."
    }
  }
  task deliveries "Milestones" {
  }
}
</pre></div>
    <p class="manual">Similar to resources, tasks are declared by using the task keyword followed by an ID and a name string. All TaskJuggler properties have their own namespaces. This means, that it is quite OK to have a resource and a task with the same ID. Tasks may have optional attributes which can be tasks again, so tasks can be nested. In contrast to all other TaskJuggler properties, task IDs inherit the ID of the enclosing task as a prefix to the ID. The full ID of the spec task is AcSo.spec. You need to use this absolute ID when you want to reference the task later on. This hierarchical name space for tasks was chosen to support large projects where multiple project managers may use the same ID in different sub tasks.</p>
    <p class="manual">To track important milestones of the project, we also added a task called Milestones. This task, like most of the other tasks will get some subtasks later on.</p>
    <p class="manual">We consider the specification task simple enough, so we don't have to break it into further subtasks. So let's add some more details to it.</p>
    <div class="codeframe"><pre class="code">  task spec "Specification" {
    effort 20d
    ${allocate_developers}
    depends !deliveries.start
  }
</pre></div>
    <p class="manual">The <a href="effort.html">effort</a> to complete the task is specified with 20 man-days. Alternatively we could have used the <a href="length.html">length</a> attribute or the <a href="duration.html">duration</a> attribute. <code class="manual">length</code> specifies the duration of the task in working days while <code class="manual">duration</code> specifies the duration in calendar days. Contrary to <code class="manual">effort</code>, these two don't have to have a specification of the involved resources. Since <code class="manual">effort</code> specifies the duration in man-days, we need to say who should be allocated to the task. The task won't finish before the resources could be allocated long enough to reach the specified effort. Tasks with <code class="manual">length</code> or <code class="manual">duration</code> criteria and allocated resources will last exactly as long as requested. Resources will be allocated only if available. It's possible that such a tasks ends up with no allocations at all since the resources are always assigned to other tasks for that period. Each task can only have one of the three duration criteria. Container tasks may never have a duration specification. They are automatically adjusted to fit all sub tasks.</p>
    <p class="manual">Here we use the allocate_developers macro mentioned above. The expression <code class="manual">${allocate_developers}</code> is simply expanded to</p>
    <div class="codeframe"><pre class="code">  allocate dev1
  allocate dev2
  allocate dev3
</pre></div>
    <p class="manual">If you need to <a href="allocate.html">allocate</a> the same bunch of people to several tasks, the macro saves you some typing. You could have written the allocate attributes directly instead of using the macro. Since the allocation of multiple resources to a task is a very common place for macro usage, we found it a good idea to use it in this example as well.</p>
    <p class="manual">One more interesting thing to note is the fact that we like the resource <code class="manual">dev2</code> only to work 4 hours each day on this task, so we use the optional attribute <a href="limits.resource.html">limits.resource</a> to specify this.</p>
    <p class="manual">For TaskJuggler to schedule a task, it needs to know either the start and end criteria of a task, or one of them and a duration specification. The start and end criteria can either be fixed dates or relative dates. Relative dates are specifications of the type <i>task B starts after task A has finished</i>. Or in other words, task B depends on task A. In this example the spec task depends on a subtasks of the deliveries task. We have not specified it yet, but it has the local ID start.</p>
    <p class="manual">To specify the dependency between the two tasks, we use the <a href="depends.html">depends</a> attribute. This attribute must be followed by one or more task IDs. If more than one ID is specified, each ID has to be separated with a comma from the previous one. Task IDs can be either absolute IDs or relative IDs. An absolute ID of a task is the ID of this task prepended by the IDs of all enclosing tasks. The task IDs are separated by a dot from each other. The absolute ID of the specification task would be <code class="manual">AcSo.spec</code>.</p>
    <p class="manual">Relative IDs always start with one or more exclamation marks. Each exclamation mark moves the scope to the next enclosing task. So <code class="manual">!deliveries.start</code> is expanded to <code class="manual">AcSo.deliveries.start</code> since <code class="manual">AcSo</code> is the enclosing task of deliveries. Relative task IDs are a little bit confusing at first, but have a real advantage over absolute IDs. Sooner or later you want to move tasks around in your project and then it's a lot less likely that you have to fix dependency specifications of relative IDs.</p>
    <p class="manual">The software development task is still too complex to specify it directly. So we split it further into subtasks.</p>
    <div class="codeframe"><pre class="code">  task software "Software Development" {
    priority 1000
    task database "Database coupling" {
      journalentry 2002-02-03 "Problems with the SQL Libary" {
        author dev1
        alert yellow
        summary -8&lt;-
          We ran into some compatibility problems with the SQL
          Library.
        -&gt;8-
        details -8&lt;-
          We have already contacted the vendor and are now waiting for
          their advise.
        -&gt;8-
      }
    }
    task gui "Graphical User Interface" {
    }
    task backend "Back-End Functions" {
    }
  }
</pre></div>
    <p class="manual">We use the <a href="priority.html">priority</a> attribute to mark the importance of the tasks. 500 is the default priority of top-level tasks. Setting the priority to 1000 marks the task as most important task, since the possible range is 1 (not important at all) to 1000 (ultimately important). priority is an attribute that is passed down to subtasks if specified before the subtasks' declaration. So all subtasks of software have a priority of 1000 as well, unless they have their own priority definition.</p>
    <div class="codeframe"><pre class="code">    task database "Database coupling" {
      effort 20d
      allocate dev1, dev2
      journalentry 2002-02-03 "Problems with the SQL Libary" {
        author dev1
        alert yellow
        summary -8&lt;-
          We ran into some compatibility problems with the SQL
          Library.
        -&gt;8-
        details -8&lt;-
          We have already contacted the vendor and are now waiting for
          their advise.
        -&gt;8-
      }
    }
</pre></div>
    <p class="manual">The work on the database coupling should not start before the specification has been finished. So we again use the <a href="depends.html">depends</a> attribute to let TaskJuggler know about this. This time we use two exclamation marks for the relative ID. The first one puts us in the scope of the enclosing software task. The second one is to get into the AcSo scope that contains the spec tasks. For a change, we <a href="allocate.html">allocate</a> resources directly without using a macro.</p>
    <div class="codeframe"><pre class="code">    task gui "Graphical User Interface" {
      effort 35d
      delayed:effort 40d
      depends !database, !backend
      allocate dev2, dev3
    }
</pre></div>
    <p class="manual">TaskJuggler can schedule your project for two different <a href="scenario.html">
scenarios</a>. We have called the first scenario <code class="manual">plan</code> scenario and the second <code class="manual">delayed</code> scenario. Many of the reports allow you to put the values of both scenarios side by side to each other, so you can compare the scenarios. All scenario-specific values that are not explicitly stated for the <code class="manual">delayed</code> scenario are taken from the <code class="manual">plan</code> scenario. So the user only has to specify the values that differ in the delayed scenario. The two scenarios must have the same task structure and the same dependencies. But the start and end dates of tasks as well as the duration may vary. In the example we have planned the work on the graphical user interface to be 35 man-days. It turned out that we actually needed 40 man-days. By prefixing the <a href="effort.html">effort</a> attribute with <code class="manual">delayed:</code>, the effort value for the <code class="manual">delayed</code> scenario can be specified.</p>
    <div class="codeframe"><pre class="code">    task backend "Back-End Functions" {
      effort 30d
      complete 95
      depends !database
      allocate dev1, dev2
    }
</pre></div>
    <p class="manual">By default, TaskJuggler assumes that all tasks are on schedule. Sometimes you want to generate reports that show how much of a task actually has been completed. TaskJuggler uses the current date for this, unless you have specified another date using the now attribute. If a task is ahead of schedule or late, this can be specified using the <a href="complete.html">complete</a> attribute. This specifies how many percent of the task have been completed up to the current date. In our case the back-end implementation is slightly ahead of schedule as we will see from the report.</p>
    <div class="codeframe"><pre class="code">  task test "Software testing" {

    task alpha "Alpha Test" {
      effort 1w
      depends !!software
      allocate test, dev2
      note "Hopefully most bugs will be found and fixed here."
      journalentry 2002-03-01 "Contract with Peter not yet signed" {
        author boss
        alert red
        summary -8&lt;-
          The paperwork is stuck with HR and I can't hunt it down.
        -&gt;8-
        details -8&lt;-
          If we don't get the contract closed within the next week,
          the start of the testing is at risk.
        -&gt;8-
      }
    }

    task beta "Beta Test" {
      effort 4w
      depends !alpha
      allocate test, dev1
    }
  }
</pre></div>
    <p class="manual">The software testing task has been split up into an alpha and a beta test task. The interesting thing here is, that efforts can not only be specified as man-days, but also man-weeks, man-hours, etc. By default, TaskJuggler assumes a man-day is 8 hours, man-week is 40 man-hours or 5 man-days. The conversion factor can be changed using the <a href="dailyworkinghours.html">dailyworkinghours</a> attribute.</p>
    <p class="manual">Let's go back to the outermost task again. At the beginning of the example we stated that we want to credit all development work to one account with ID dev and all documentation work to the account doc. To achieve this, we use the attribute <a href="chargeset.html">chargeset</a> to credit all tasks to the <code class="manual">dev</code> account.</p>
    <p class="manual">For the duration of the <code class="manual">AcSo</code> task we also have running costs for the lease on the building and the equipment. To compensate this, we charge a daily rate of USD 170 per day using the <a href="charge.html">charge</a> attribute.</p>
    <div class="codeframe"><pre class="code">task AcSo "Accounting Software" {
  chargeset dev
  charge 170 perday
  task spec "Specification" {
</pre></div>
    <p class="manual">Since we specify the attribute for the top-level task before we declare any subtasks, this attribute will be inherited by all subtasks and their subtasks and so on. The only exception is the writing of the manual. We need to change the chargeset for this task again, as it is also a subtask of AcSo and we want to use a different account for it.</p>
    <div class="codeframe"><pre class="code">  task manual "Manual" {
    effort 10w
    depends !deliveries.start
    allocate doc, dev3
    purge chargeset
    chargeset doc
    journalentry 2002-02-28 "User manual completed" {
      author boss
      summary "The doc writers did a really great job to finish on time."
    }
  }
</pre></div>
    <h2 class="manual" id="Specifying_Milestones">4.8 Specifying Milestones</h2>
    <p class="manual">All tasks that have been discussed so far, had a certain duration. We did not always specify the duration explicitly, but we expect them to last for a certain period of time. Sometimes you just want to capture a certain moment in your project plan. These moments are usually called milestones, since they have some level of importance for the progress of the project.</p>
    <p class="manual">TaskJuggler has support for milestones as well. Milestones are leaf tasks that don't have a duration specification.</p>
    <div class="codeframe"><pre class="code">  task deliveries "Milestones" {
    purge chargeset
    chargeset rev

    task start "Project start" {
      start ${projectstart}
      delayed:start 2002-01-20
      charge 21000.0 onstart
    }

    task prev "Technology Preview" {
      depends !!software.backend
      charge 31000.0 onstart
      note "All '''major''' features should be usable."
    }

    task beta "Beta version" {
      depends !!test.alpha
      charge 13000.0 onstart
      note "Fully functional, may contain bugs."
    }

    task done "Ship Product to Customer" {
      # maxend 2002-04-17
      depends !!test.beta, !!manual
      charge 33000.0 onstart
      note "All priority 1 and 2 bugs must be fixed."
    }
  }
}
</pre></div>
    <p class="manual">We have put all important milestones of the project as subtasks of the deliveries task. This way they show up nicely grouped in the reports. All milestones either have a dependency or a fixed start date. For the first milestone we have used the attribute <a href="start.html">start</a> to set a fixed start date. All other tasks have direct or indirect dependencies on this task. Moving back the start date will slip the whole project. This has actually happened, so we use the <code class="manual">delayed:</code> prefix again to specify the start date for the delayed scenario.</p>
    <p class="manual">Every milestone is linked to a customer payment. By using the <a href="charge.html">charge</a> attribute we can credit the specified amount to the account associated with this task. Since we have assigned the <code class="manual">rev</code> account to the enclosing task, all milestones will use this account as well. This time, we use the keyword <code class="manual">onstart</code> to indicate that this is not a continuous charge but a one-time charge that is credited at the begin of the task.</p>
    <p class="manual">Did you notice the line in the task done that starts with a hash? This line is commented out. If TaskJuggler finds a hash, it ignores the rest of the line. This way you can include comments in your project. The <a href="maxend.html">maxend</a> attribute specifies that the task should end no later than the specified date. This information is not used for scheduling, but only for checking the schedule afterwards. Since the task will end later than the specified date, commenting out the line would trigger a warning.</p>
    <p class="manual">Now the project has been completely specified. Stopping here would result in a valid TaskJuggler file that could be processed and scheduled. But no reports would be generated to visualize the results.</p>
    <h2 class="manual" id="Visualizing_the_Project">4.9 Visualizing the Project</h2>
    <p class="manual">To see and share the project data you reports can be generated. You can generate any number of reports and you can select from a variety of report types and output formats. To have a report generated after the project scheduling has been completed, you need include a report definition into the project description. Report definitions are properties that are very similar to the task and resource properties that you are already familiar with. Just like these, report definitions can be nested to take advantage of the attribute inheritance mechanism. Every report definition starts with the type of the report. Each type of report has a particular focus. A <a href="taskreport.html">taskreport</a> lists the project data in the form of a task list. A <a href="resourcereport.html">resourcereport</a> does the same in form of a resource list. For a more generic report, you can use the <a href="textreport.html">textreport</a>.</p>
    <p class="manual">A <code class="manual">textreport</code> does not directly present the data in form of a task or resource list. It just consists of text building blocks that are described by <a href="Rich_Text_Attributes.html">Rich Text</a>. There can be a building block at the top and bottom, as well as three columns in the center. The column are called <code class="manual">left</code>, <code class="manual">center</code> and <code class="manual">right</code>.</p>
    <p class="manual">For our first report, we'll just use the center column for now. Like every property, you need to specify a name. This name will be the base name of the generated report file. Depending on the output format, the proper suffix is appended. For this report, we only chose to generate a web page in HTML format. There is no default format defined for reports. If the <a href="formats.html">formats</a> attribute is not specified, no output file will be generated for the report specification.</p>
    <p class="manual">This may seem odd at first glance since TaskJuggler syntax always tries to use the most compact and readable syntax for the common case. As you will see in a minute, reports may be composed of several report specifications. One report specification can include the output of another report specification as well. In this case, the included report does not need to generate it's own file. The output will be included within the output of another report specification. In case of such composed reports, the output format specification of the top-level format will be used for all included reports as well.</p>
    <div class="codeframe"><pre class="code">textreport frame "" {
  textreport index "Overview" {
    formats html
    center '&lt;[report id="overview"]&gt;'
  }
}
</pre></div>
    <p class="manual">For the main report, we choose the file name <code class="manual">Overview</code> and the format <code class="manual">html</code>. So, the generated file will be called <code class="manual">Overview.html</code>.</p>
    <p class="manual">As we've mentioned before, the sections of a <code class="manual">textreport</code> are defined in Rich Text format. Here we use a so called block generator to include the HTML output of another report definition. The <code class="manual">report</code> block generator allows us to compose reports by combining their output into a single report. You must provide the <code class="manual">id</code> parameter to specify which report definition you would like to use. In this case, it is a report definition with the ID <code class="manual">overview</code>. Note that generator parameters need to be enclosed in single or double quotes. We are essentially marking a string within a string. This can only work out, if we don't use the same parameter for both. Let's define this report first.</p>
    <div class="codeframe"><pre class="code">taskreport overview "" {
  columns bsi { title 'WBS' },
          name, start, end, effort, cost,
          revenue, chart { ${TaskTip} }
}
</pre></div>
    <p class="manual">Instead of another <a href="textreport.html">textreport</a> definition we are now using a <a href="taskreport.html">taskreport</a>. A task report contains a list of tasks in a table structure. By default, it contains all tasks of the project. As we will see later on, we can use filter expressions to limit the content to a well defined subset of tasks. The table contains a line for each task and comes by default with a few columns like the name of the task, and the start and end dates. For this project overview report, we like to have also the effort for each task, the duration, the effort, the cost and revenue numbers included. To top it off, we also include a column with a Gantt chart.</p>
    <p class="manual">By including the cost and revenue column, we are able to do a simple profit and loss analysis on the project. This P&amp;L is computed from the accounts that we have provided above. For this to work, we need to tell TaskJuggler which accounts are cost accounts and which are revenue accounts. We have already conveniently grouped the accounts and the <a href="balance.html">balance</a> attribute specifies which accounts are used for the P&amp;L in this report.</p>
    <div class="codeframe"><pre class="code">  balance cost rev
</pre></div>
    <p class="manual">The columns of the report can be customized. You can overwrite the default title or the cell content. See <a href="columns.html">columns</a> for a full list of available attributes. For the chart column, we'd like to have a tool tip that displays additional details when the mouse pointer is placed over a task bar. Since we use this tool tip in several reports, we have defined the <code class="manual">TaskTip</code> macro for it.</p>
    <div class="codeframe"><pre class="code">macro TaskTip [
  tooltip istask() -8&lt;-
    '''Start: ''' &lt;-query attribute='start'-&gt;
    '''End: ''' &lt;-query attribute='end'-&gt;
    ----
    '''Resources:'''

    &lt;-query attribute='resources'-&gt;
    ----
    '''Precursors: '''

    &lt;-query attribute='precursors'-&gt;
    ----
    '''Followers: '''

    &lt;-query attribute='followers'-&gt;
    -&gt;8-
]
</pre></div>
    <p class="manual">The <a href="tooltip.column.html">tooltip</a> attribute describes the content of the tool tip. The first parameter is a logical expression that determines when the tool tip is active. You can specify multiple tool tips. The first matching one is being displayed. The condition is evaluated for each report line. The <code class="manual">istask()</code> function only evaluates to true for task lines. See <a href="functions.html">functions</a> for a complete list of functions that can be used in <a href="logicalexpression.html">logical expressions</a>.</p>
    <p class="manual">The content of the tool tip is a template that uses <a href="Rich_Text_Attributes.html#Block_and_Inline_Generators">query
generators</a> to include task attributes such as the start and end date.</p>
    <p class="manual">We have chosen to include the start and end date of each task in the report. By default, TaskJuggler lists dates as day, month and year. We like the format to be similar to the format that the project syntax uses, but also like to include the weekday. To change the date format, the <a href="timeformat.html">timeformat</a> attribute can be used.</p>
    <p class="manual">The project will last a few weeks. The most convenient unit to list efforts in is man or resource days. The <a href="loadunit.html">loadunit</a> attribute tells TaskJuggler to list the load of each task or resource in man days. Since this will just be a number without a unit, it is advisable to include a small hint for the reader that these values are indeed man or resource days. The caption of the table is a convenient place to put this information by using the <a href="caption.html">caption</a> attribute.</p>
    <div class="codeframe"><pre class="code">  timeformat "%a %Y-%m-%d"
  loadunit days
  caption 'All effort values are in man days.'
</pre></div>
    <p class="manual">The <code class="manual">taskreport</code> can contain more than just the table. It is not as flexible as the <code class="manual">textreport</code>, but still has support for a header and footer. Let's look at the header first. We not only like to put a headline here, but several paragraphs of text. The <a href="header.html">header</a> attribute is a <a href="Rich_Text_Attributes.html">Rich Text</a> attribute just like <a href="center.html">center</a>. We could enclose it in single or double quotes again. But for Strings that span multiple lines and potentially include single or double quotes as well, scissor-marks or cut-here-marks are recommended. These marks look like a pair of scissors that cut along a dashed line. Use <code class="manual">-8&lt;-</code> to begin a string and <code class="manual">-&gt;8-</code> to terminate it. The opening cut mark must be immediately followed by a line break. The indentation of the following line defines the indentation that will be ignored for all lines of the string. The following lines must have at least the same indentation. The indentation that exceeds the indentation of the first line will be kept in the resulting string. With this feature, you can define multi-line Rich Text strings without disturbing the indentation structure of your project file.</p>
    <div class="codeframe"><pre class="code">  header -8&lt;-
    === Project Overview ===

    The project is structured into 3 phases.

    # Specification
    # &lt;-reportlink id='frame.development'-&gt;
    # Testing

    === Original Project Plan ===
  -&gt;8-
</pre></div>
    <p class="manual">Section headers are surrounded by <code class="manual">==</code>. The number of equal signs, define the section level. You need to start with two equal characters for the first level. Text that is surrounded by blank lines will create a paragraph. Bullet lists can be made by starting a line with a <code class="manual">#</code> character. Remember that the indentation of cut-mark strings will be ignored. Your <code class="manual">#</code> character must not be the first character in the line as long it is only preceded by the exact same number of blanks as the first line of the cut-mark string.</p>
    <p class="manual">If you want to reference other reports from this report, you can include the file name of this report by <code class="manual">[[</code> and <code class="manual">]]</code>. Don't include the extension of the file name, it will be automatically appended. The actual representation of the reference depends on the chosen output format. For HTML output, the reference is a click-able link to the referenced report file.</p>
    <p class="manual">For the <a href="footer.html">footer</a> we can proceed accordingly. We just add a few more paragraphs of text the describe certain aspects of the project. By putting it all together, we end up with the following report definition.</p>
    <div class="codeframe"><pre class="code">taskreport overview "" {
  header -8&lt;-
    === Project Overview ===

    The project is structured into 3 phases.

    # Specification
    # &lt;-reportlink id='frame.development'-&gt;
    # Testing

    === Original Project Plan ===
  -&gt;8-
  columns bsi { title 'WBS' },
          name, start, end, effort, cost,
          revenue, chart { ${TaskTip} }
  # For this report we like to have the abbreviated weekday in front
  # of the date. %a is the tag for this.
  timeformat "%a %Y-%m-%d"
  loadunit days
  hideresource 1
  balance cost rev
  caption 'All effort values are in man days.'

  footer -8&lt;-
    === Staffing ===

    All project phases are properly staffed. See [[ResourceGraph]] for
    detailed resource allocations.

    === Current Status ===

    The project started off with a delay of 4 days. This slightly affected
    the original schedule. See [[Deliveries]] for the impact on the
    delivery dates.
  -&gt;8-
}
</pre></div>
    <p class="manual">The generated report can be found <a href="http://www.taskjuggler.org/tj3/examples/Overview.html" target="_top">here</a>. It servers as an entry page for the other reports. While it already contains some references, a navigator bar would be handy as well. Fortunately, there is a block generator called 'navigator' to take care of this. But before we can include the navigator in the report, we need to define it first.</p>
    <div class="codeframe"><pre class="code">navigator navbar {
  hidereport 0
}
</pre></div>
    <p class="manual">
     <a href="hidereport.html">hidereport</a> is a filter attribute. The logical expression determines which reports will be included in the navigator bar. A logical expression of 0 means hide no reports, so all are included.</p>
    <p class="manual">The best place to put a navigator bar in the report is right at the top. We use two horizontal lines to separate the navigator from the main headline and the rest of the report. <code class="manual">----</code> at the begin of the line create such a horizontal separation line.</p>
    <div class="codeframe"><pre class="code">textreport frame "" {
  header -8&lt;-
    == Accounting Software Project ==
    &lt;[navigator id="navbar"]&gt;
  -&gt;8-
  footer "----"
  textreport index "Overview" {
    formats html
    center '&lt;[report id="overview"]&gt;'
  }
}
</pre></div>
   </div></div>
  <br/>
  <hr/>
  <table style="width:90%; margin-left:5%; margin-right:5%"><tr>
    <td style="text-align:left; width:35%;">&lt;&lt; <a href="Getting_Started.html">Getting_Started</a> &lt;&lt;</td>
    <td style="text-align:center; width:30%;"><a href="toc.html">Table Of Contents</a></td>
    <td style="text-align:right; width:35%;">&gt;&gt; <a href="The_TaskJuggler_Syntax.html">The_TaskJuggler_Syntax</a> &gt;&gt;</td>
   </tr></table>
  <hr/>
  <br/>
  <div align="center" style="font-size:10px;">Copyright (c) 2006, 2007, 2008, 2009, 2010, 2011, 2012 by Chris Schlaeger &lt;chris@linux.com&gt;.<a href="http://www.taskjuggler.org">TaskJuggler</a> is a trademark of Chris Schlaeger.</div>
 </body>
</html>
